﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Text.RegularExpressions;


namespace HTMLBuilder
{
    public class RepeaterSimulate
    {
        public  string ItemTemplate { get; set; }
        /// <summary>
        /// Generate HTML 
        /// </summary>
        /// <param name="obj">datasource</param>
        /// <returns></returns>
        public string GenerateHTML<T>(object obj)
        {
            StringBuilder sb = new StringBuilder();
            IEnumerable<T> enumerable = obj as IEnumerable<T>;

            MemberInfo[] myMemberInfo;

            // Get the type of 'MyClass'.
            Type myType = typeof(T);

            // Get the information related to all public member's of 'MyClass'. 
            myMemberInfo = myType.GetMembers();

            string regexText = "#\\w{1,}#";
            Match mt = Regex.Match(this.ItemTemplate, regexText);
            List<string> results = RegularHelper.GetResult(mt);
            foreach (var item in enumerable)
            {
                string tempStr = this.ItemTemplate;
                for (int i = 0; i < myMemberInfo.Length; i++)
                {
                   
                    if (myMemberInfo[i].MemberType.ToString() == "Property")
                    {
                        if (results.Contains(myMemberInfo[i].Name))
                        {
                            
                            object v = myType.InvokeMember(myMemberInfo[i].Name,
           BindingFlags.DeclaredOnly |
           BindingFlags.Public | BindingFlags.NonPublic |
           BindingFlags.Instance | BindingFlags.GetProperty, null, item, null);
                            tempStr = tempStr.Replace("#" + myMemberInfo[i].Name + "#", v.ToString());                         
                        }                     
                    }
                 
                }
                sb.Append(tempStr);
            }

            return sb.ToString();
        }

      

    }
}
